// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.12.4
// source: answer/answer_svc.proto

package answer

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// AnswerServiceClient is the client API for AnswerService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type AnswerServiceClient interface {
	SetAnswer(ctx context.Context, opts ...grpc.CallOption) (AnswerService_SetAnswerClient, error)
	GetAnswersByStudent(ctx context.Context, opts ...grpc.CallOption) (AnswerService_GetAnswersByStudentClient, error)
	GetAnswersByQuestion(ctx context.Context, opts ...grpc.CallOption) (AnswerService_GetAnswersByQuestionClient, error)
	SetScore(ctx context.Context, opts ...grpc.CallOption) (AnswerService_SetScoreClient, error)
}

type answerServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewAnswerServiceClient(cc grpc.ClientConnInterface) AnswerServiceClient {
	return &answerServiceClient{cc}
}

func (c *answerServiceClient) SetAnswer(ctx context.Context, opts ...grpc.CallOption) (AnswerService_SetAnswerClient, error) {
	stream, err := c.cc.NewStream(ctx, &AnswerService_ServiceDesc.Streams[0], "/answer.AnswerService/SetAnswer", opts...)
	if err != nil {
		return nil, err
	}
	x := &answerServiceSetAnswerClient{stream}
	return x, nil
}

type AnswerService_SetAnswerClient interface {
	Send(*Answer) error
	Recv() (*SetAnswerResponse, error)
	grpc.ClientStream
}

type answerServiceSetAnswerClient struct {
	grpc.ClientStream
}

func (x *answerServiceSetAnswerClient) Send(m *Answer) error {
	return x.ClientStream.SendMsg(m)
}

func (x *answerServiceSetAnswerClient) Recv() (*SetAnswerResponse, error) {
	m := new(SetAnswerResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *answerServiceClient) GetAnswersByStudent(ctx context.Context, opts ...grpc.CallOption) (AnswerService_GetAnswersByStudentClient, error) {
	stream, err := c.cc.NewStream(ctx, &AnswerService_ServiceDesc.Streams[1], "/answer.AnswerService/GetAnswersByStudent", opts...)
	if err != nil {
		return nil, err
	}
	x := &answerServiceGetAnswersByStudentClient{stream}
	return x, nil
}

type AnswerService_GetAnswersByStudentClient interface {
	Send(*GetAnswerRequest) error
	Recv() (*ShowAnswersPerStudentResponse, error)
	grpc.ClientStream
}

type answerServiceGetAnswersByStudentClient struct {
	grpc.ClientStream
}

func (x *answerServiceGetAnswersByStudentClient) Send(m *GetAnswerRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *answerServiceGetAnswersByStudentClient) Recv() (*ShowAnswersPerStudentResponse, error) {
	m := new(ShowAnswersPerStudentResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *answerServiceClient) GetAnswersByQuestion(ctx context.Context, opts ...grpc.CallOption) (AnswerService_GetAnswersByQuestionClient, error) {
	stream, err := c.cc.NewStream(ctx, &AnswerService_ServiceDesc.Streams[2], "/answer.AnswerService/GetAnswersByQuestion", opts...)
	if err != nil {
		return nil, err
	}
	x := &answerServiceGetAnswersByQuestionClient{stream}
	return x, nil
}

type AnswerService_GetAnswersByQuestionClient interface {
	Send(*GetAnswerRequest) error
	Recv() (*ShowAnswerPerQuestionResponse, error)
	grpc.ClientStream
}

type answerServiceGetAnswersByQuestionClient struct {
	grpc.ClientStream
}

func (x *answerServiceGetAnswersByQuestionClient) Send(m *GetAnswerRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *answerServiceGetAnswersByQuestionClient) Recv() (*ShowAnswerPerQuestionResponse, error) {
	m := new(ShowAnswerPerQuestionResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *answerServiceClient) SetScore(ctx context.Context, opts ...grpc.CallOption) (AnswerService_SetScoreClient, error) {
	stream, err := c.cc.NewStream(ctx, &AnswerService_ServiceDesc.Streams[3], "/answer.AnswerService/SetScore", opts...)
	if err != nil {
		return nil, err
	}
	x := &answerServiceSetScoreClient{stream}
	return x, nil
}

type AnswerService_SetScoreClient interface {
	Send(*GetAnswerRequest) error
	Recv() (*SetAnswerResponse, error)
	grpc.ClientStream
}

type answerServiceSetScoreClient struct {
	grpc.ClientStream
}

func (x *answerServiceSetScoreClient) Send(m *GetAnswerRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *answerServiceSetScoreClient) Recv() (*SetAnswerResponse, error) {
	m := new(SetAnswerResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// AnswerServiceServer is the server API for AnswerService service.
// All implementations must embed UnimplementedAnswerServiceServer
// for forward compatibility
type AnswerServiceServer interface {
	SetAnswer(AnswerService_SetAnswerServer) error
	GetAnswersByStudent(AnswerService_GetAnswersByStudentServer) error
	GetAnswersByQuestion(AnswerService_GetAnswersByQuestionServer) error
	SetScore(AnswerService_SetScoreServer) error
	mustEmbedUnimplementedAnswerServiceServer()
}

// UnimplementedAnswerServiceServer must be embedded to have forward compatible implementations.
type UnimplementedAnswerServiceServer struct {
}

func (UnimplementedAnswerServiceServer) SetAnswer(AnswerService_SetAnswerServer) error {
	return status.Errorf(codes.Unimplemented, "method SetAnswer not implemented")
}
func (UnimplementedAnswerServiceServer) GetAnswersByStudent(AnswerService_GetAnswersByStudentServer) error {
	return status.Errorf(codes.Unimplemented, "method GetAnswersByStudent not implemented")
}
func (UnimplementedAnswerServiceServer) GetAnswersByQuestion(AnswerService_GetAnswersByQuestionServer) error {
	return status.Errorf(codes.Unimplemented, "method GetAnswersByQuestion not implemented")
}
func (UnimplementedAnswerServiceServer) SetScore(AnswerService_SetScoreServer) error {
	return status.Errorf(codes.Unimplemented, "method SetScore not implemented")
}
func (UnimplementedAnswerServiceServer) mustEmbedUnimplementedAnswerServiceServer() {}

// UnsafeAnswerServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to AnswerServiceServer will
// result in compilation errors.
type UnsafeAnswerServiceServer interface {
	mustEmbedUnimplementedAnswerServiceServer()
}

func RegisterAnswerServiceServer(s grpc.ServiceRegistrar, srv AnswerServiceServer) {
	s.RegisterService(&AnswerService_ServiceDesc, srv)
}

func _AnswerService_SetAnswer_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(AnswerServiceServer).SetAnswer(&answerServiceSetAnswerServer{stream})
}

type AnswerService_SetAnswerServer interface {
	Send(*SetAnswerResponse) error
	Recv() (*Answer, error)
	grpc.ServerStream
}

type answerServiceSetAnswerServer struct {
	grpc.ServerStream
}

func (x *answerServiceSetAnswerServer) Send(m *SetAnswerResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *answerServiceSetAnswerServer) Recv() (*Answer, error) {
	m := new(Answer)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _AnswerService_GetAnswersByStudent_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(AnswerServiceServer).GetAnswersByStudent(&answerServiceGetAnswersByStudentServer{stream})
}

type AnswerService_GetAnswersByStudentServer interface {
	Send(*ShowAnswersPerStudentResponse) error
	Recv() (*GetAnswerRequest, error)
	grpc.ServerStream
}

type answerServiceGetAnswersByStudentServer struct {
	grpc.ServerStream
}

func (x *answerServiceGetAnswersByStudentServer) Send(m *ShowAnswersPerStudentResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *answerServiceGetAnswersByStudentServer) Recv() (*GetAnswerRequest, error) {
	m := new(GetAnswerRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _AnswerService_GetAnswersByQuestion_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(AnswerServiceServer).GetAnswersByQuestion(&answerServiceGetAnswersByQuestionServer{stream})
}

type AnswerService_GetAnswersByQuestionServer interface {
	Send(*ShowAnswerPerQuestionResponse) error
	Recv() (*GetAnswerRequest, error)
	grpc.ServerStream
}

type answerServiceGetAnswersByQuestionServer struct {
	grpc.ServerStream
}

func (x *answerServiceGetAnswersByQuestionServer) Send(m *ShowAnswerPerQuestionResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *answerServiceGetAnswersByQuestionServer) Recv() (*GetAnswerRequest, error) {
	m := new(GetAnswerRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _AnswerService_SetScore_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(AnswerServiceServer).SetScore(&answerServiceSetScoreServer{stream})
}

type AnswerService_SetScoreServer interface {
	Send(*SetAnswerResponse) error
	Recv() (*GetAnswerRequest, error)
	grpc.ServerStream
}

type answerServiceSetScoreServer struct {
	grpc.ServerStream
}

func (x *answerServiceSetScoreServer) Send(m *SetAnswerResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *answerServiceSetScoreServer) Recv() (*GetAnswerRequest, error) {
	m := new(GetAnswerRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// AnswerService_ServiceDesc is the grpc.ServiceDesc for AnswerService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var AnswerService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "answer.AnswerService",
	HandlerType: (*AnswerServiceServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "SetAnswer",
			Handler:       _AnswerService_SetAnswer_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
		{
			StreamName:    "GetAnswersByStudent",
			Handler:       _AnswerService_GetAnswersByStudent_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
		{
			StreamName:    "GetAnswersByQuestion",
			Handler:       _AnswerService_GetAnswersByQuestion_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
		{
			StreamName:    "SetScore",
			Handler:       _AnswerService_SetScore_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "answer/answer_svc.proto",
}
